#include "Device.h"
#include "Operation.h"
#include "Bottle.h"
using namespace std;

RootDevice::RootDevice(string nm, int lSize) {
    name = nm;
    lineSize = lSize;
}

int RootDevice::getLineSize() {
    return lineSize;
}

int RootDevice::getBottlesCount() {
    return bottlesLine.size();
}

void RootDevice::doJob(Bottle* bottle) {
    bottle->addOperation(name);
    bottlesLine.push_back(bottle); 
}

Bottle* RootDevice::getBottle() {
    vector<Bottle*>::iterator eng = bottlesLine.end();
    eng--;
    return (*eng);
}

void RootDevice::clearPointer() {
    vector<Bottle*>::iterator eng = bottlesLine.end();
    eng--;
    bottlesLine.erase(eng);
}

void RootDevice::closeFile() {} 
//---------------------------------------------------------
TapDevice::TapDevice(string nm, int lSize)
: RootDevice(nm, lSize) {
    name = nm;
    lineSize = lSize;
}
//---------------------------------------------------------
CapDevice::CapDevice(string nm, int lSize)
: RootDevice(nm, lSize) {
    name = nm;
    lineSize = lSize;

}
//---------------------------------------------------------
LabelDevice::LabelDevice(string nm, int lSize)
: RootDevice(nm, lSize) {
    name = nm;
    lineSize = lSize;

}
//---------------------------------------------------------
StatisticDevice::StatisticDevice(string nm, int lSize)
: RootDevice(nm, lSize) {
    name = nm;
    lineSize = lSize;
    didBottles = 0;
    badBottles = 0;
    outFile.open("output.txt", ofstream::out | ofstream::trunc);
    outFile << " Bottle Nr\t | Tap\t | Cap\t | Label | Total | Good | Bad |" << endl;
    outFile << " -----------------------------------------------------------------------" << endl;
}

void StatisticDevice::doJob(Bottle* device) {
    int bad = 0;
    int x = 0;
    didBottles++;
    string load = "+";
    string cork = "+";
    string label = "+";

    vector<Operation*>::iterator access = device->getOperationsBegin();
    
    for (; access != device->getOperationsEnd(); access++) {
        if (((*access)->getError() == true ) &&  (x == 1)){
            bad++;
            load = "-";
        } 
        else if (((*access)->getError() == true ) &&  (x == 2)){
            bad++;
            cork = "-";
        }
        else if (((*access)->getError() == true ) &&  (x == 3)){
            bad++;
            label = "-";
        }
        x++;
    }
    if (bad != 0) badBottles++;
    outFile << " Bottle_" << didBottles << "\t | " << load << "\t | "<< cork << "\t | " << label << "\t | "<< didBottles << " \t | " << (didBottles-badBottles) << " \t | " << badBottles << " | "<< endl;
    delete device;
}

void StatisticDevice::closeFile() {
     outFile.close();
}
