#ifndef __Device_h
#define __Device_h

#include <string>
#include <fstream>
#include <vector>
#include "Bottle.h"

class RootDevice {
    protected:
      std::string name;
      std::vector<Bottle*> bottlesLine;
      int lineSize;
    public:
      RootDevice(std::string name, int lineSize);
      std::string getName();
      int getLineSize();
      virtual void doJob(Bottle* bottle);
      Bottle* getBottle();
      int getBottlesCount();
      void clearPointer();
      virtual void closeFile();
};

//----------------------------------------------------

class TapDevice : public RootDevice {
  public:   
    TapDevice(std::string name, int lineSize);
};

//----------------------------------------------------

class CapDevice : public RootDevice {
   public:   
    CapDevice(std::string name, int lineSize);
};

//----------------------------------------------------


class LabelDevice : public RootDevice {
   public:   
    LabelDevice(std::string name, int lineSize);
};

//----------------------------------------------------

class StatisticDevice : public RootDevice {
  protected:
    int didBottles;
    int badBottles;        
    std::ofstream outFile;
  public:   
    StatisticDevice(std::string name, int lineSize);
    virtual void doJob(Bottle* bottle);
    virtual void closeFile(); 
};

//----------------------------------------------------

#endif
